import java.io.*;
import java.util.Random;
import java.util.StringTokenizer;

public class Main {
    static Random random = new Random();

    public static void main(String[] args) throws Exception {
        new Main().solve();
    }

    void solve() throws Exception {
        Scanner in = new Scanner();
        PrintWriter out = new PrintWriter(System.out);
        int n = in.nextInt();
        int m = in.nextInt();
        int q = in.nextInt();
        long k = in.nextLong();

        long offline[] = new long[m];
        for (int i = 0; i < m; i++)
            offline[i] = in.nextLong();

        long table[][] = new long[n][m];
        long minSum[] = new long[n];
        long maxSum[] = new long[n];
        MySet min = new MySet();
        MySet max = new MySet();
        for (int i = 0; i < n; i++) {
            minSum[i] = 0;
            maxSum[i] = 0;
            for (int j = 0; j < m; j++) {
                table[i][j] = in.nextLong();
                minSum[i] += table[i][j];
                maxSum[i] += (table[i][j] + offline[j] == k ? k : table[i][j]);
            }
            min.insert(minSum[i]);
            max.insert(maxSum[i]);
        }

        for (int i = 0; i < q; i++) {
            int type = in.nextInt();
            int id = in.nextInt() - 1;

            if (type == 1) {
               /* out.write(min.getPlace(maxSum[id]));
                out.write(" ");
                out.write(max.getPlace(minSum[id]) - (maxSum[id] > minSum[id] ? 1 : 0));
                out.write("\n");*/
                System.out.println(min.getPlace(maxSum[id]) + " " + (max.getPlace(minSum[id]) - (maxSum[id] > minSum[id] ? 1 : 0)));
            } else {
                int taskId = in.nextInt() - 1;
                long newScore = in.nextLong();

                max.erase(maxSum[id]);
                min.erase(minSum[id]);
                minSum[id] += newScore - table[id][taskId];
                maxSum[id] -= k - newScore;
                max.insert(maxSum[id]);
                min.insert(minSum[id]);
            }
        }

        out.close();
    }

    class Scanner {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer tokenizer;

        String next() {
            if (tokenizer == null || !tokenizer.hasMoreTokens())
                try {
                    tokenizer = new StringTokenizer(in.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            return tokenizer.nextToken();
        }

        int nextInt() {
            return Integer.valueOf(next());
        }

        long nextLong() {
            return Long.valueOf(next());
        }
    }

    class MySet {
        Node root = null;

        void insert(long val) {
            Pair tmp = split(root, val);
            root = merge(tmp.X, merge(new Node(val), tmp.Y));
        }

        void erase(long val) {
            Pair tmp1 = split(root, val);
            Pair tmp2 = split(tmp1.X, val - 1);
            tmp2.Y = remove(tmp2.Y);
            root = merge(merge(tmp2.X, tmp2.Y), tmp1.Y);
        }

        int getPlace(long val) {
            Pair tmp = split(root, val);
            int res = 1 + getSize(tmp.Y);
            root = merge(tmp.X, tmp.Y);
            return res;
        }
    }

    class Node {
        long key, prior;
        int size;
        Node left, right;

        Node(long key) {
            this.key = key;
            this.prior = random.nextLong();
            this.size = 1;
        }
    }

    int getSize(Node node) {
        return (node == null ? 0 : node.size);
    }

    void update(Node node) {
        if (node == null)
            return;

        node.size = 1 + getSize(node.left) + getSize(node.right);
    }

    Node merge(Node treap1, Node treap2) {
        if (treap1 == null)
            return treap2;

        if (treap2 == null)
            return treap1;

        if (treap1.prior > treap2.prior) {
            treap1.right = merge(treap1.right, treap2);
            update(treap1);
            return treap1;
        } else {
            treap2.left = merge(treap1, treap2.left);
            update(treap2);
            return treap2;
        }
    }

    Pair split(Node treap, long val) {
        if (treap == null)
            return new Pair();

        if (treap.key > val) {
            Pair tmp = split(treap.left, val);
            treap.left = tmp.Y;
            update(treap);
            update(tmp.X);
            return new Pair(tmp.X, treap);
        } else {
            Pair tmp = split(treap.right, val);
            treap.right = tmp.X;
            update(treap);
            update(tmp.Y);
            return new Pair(treap, tmp.Y);
        }
    }

    Node remove(Node treap) {
        if (getSize(treap) <= 1)
            return null;

        if (treap.left != null)
            treap.left = remove(treap.left);
        else
            treap.right = remove(treap.right);

        update(treap);

        return treap;
    }

    class Pair {
        Node X, Y;

        Pair(Node X, Node Y) {
            this.X = X;
            this.Y = Y;
        }

        Pair() {}
    }
}
