#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

set<pair<int, int>> used;
set<pair<int, int>> have;

bool check_in(int x)
{
	if (used.empty())
	{
		return false;
	}
	else
	{
		auto it = used.upper_bound({x + 1, -1});

		if (it == used.begin())
		{
			return false;
		}
		else
		{
			--it;

			return it->first <= x && x <= it->second; 
		}
	}
}

vector<int> next(int x, int h)
{
	auto it = --used.upper_bound({x + 1, -1});
	
	vector<int> ans;
	
	if (it->second + 1 <= h)
	{
		ans.push_back(it->second + 1);
	}
	if (it->first - 1 > 0)
	{
		ans.push_back(it->first - 1);
	}

	return ans;
}

void insert(int x)
{
	if (used.empty())
	{
		used.insert({x, x});
	}
	else
	{
		auto it = used.upper_bound({x + 1, -1});
	

		if (it == used.begin())
		{
			if (x + 1 == it->first)
			{
				pair<int, int> mem = *it;
				used.erase(it);
				--mem.first;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
		else if (it == used.end())
		{
			--it;
			if (it->second == x - 1)
			{
				pair<int, int> mem = *it;
				used.erase(it);
				++mem.second;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
		else
		{
			auto itr = it;
			auto itl = --it;

			if (itl->second == x - 1 && x + 1 == itr->first)
			{
				pair<int, int> meml = *itl;
				pair<int, int> memr = *itr;
				used.erase(meml);
				used.erase(memr);
				used.insert({meml.first, memr.second});
			}
			else if (itl->second == x - 1)
			{
				pair<int, int> mem = *itl;
				used.erase(itl);
				++mem.second;
				used.insert(mem);
			}
			else if (x + 1 == itr->first)
			{
				pair<int, int> mem = *itr;
				used.erase(itr);
				--mem.first;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
	}
}

int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int min_v = atoi(argv[2]);
	int max_v = atoi(argv[3]);

	int cur_n;
	int h;
	int t;
	scanf("%d%d%d", &cur_n, &h, &t);
	for (int i = 0; i < cur_n; ++i)
	{
		int hh, vv;
		scanf("%d%d", &hh, &vv);
		have.insert({hh, vv});
		insert(hh);
	}

	
	while (cur_n < n)
	{
		++cur_n;
		int ptr = rnd.next(1, h);
		int v = rnd.next(min_v, max_v);
	
		if (!check_in(ptr))
		{
			have.insert({ptr, v});
			insert(ptr);
		}
		else
		{
			vector<int> now = next(ptr, h);
			assert(!now.empty());
			ptr = now[rnd.next(0, (int)now.size() - 1)];
			have.insert({ptr, v});
			insert(ptr);
		}
	}

	assert((int)have.size() == n);

	printf("%d %d %d\n", n, h, t);
	for (auto it = have.begin(); it != have.end(); ++it)
	{
		printf("%d %d\n", it->first, it->second);
	}

	return 0;
}


