#include "testlib.h"
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

set<pair<int, int>> used;
set<pair<int, int>> have;

bool check_in(int x)
{
	if (used.empty())
	{
		return false;
	}
	else
	{
		auto it = used.upper_bound({x + 1, -1});

		if (it == used.begin())
		{
			return false;
		}
		else
		{
			--it;

			return it->first <= x && x <= it->second; 
		}
	}
}

vector<int> next(int x, int h)
{
	auto it = --used.upper_bound({x + 1, -1});
	
	vector<int> ans;
	
	if (it->second + 1 <= h)
	{
		ans.push_back(it->second + 1);
	}
	if (it->first - 1 > 0)
	{
		ans.push_back(it->first - 1);
	}

	return ans;
}

void insert(int x)
{
	if (used.empty())
	{
		used.insert({x, x});
	}
	else
	{
		auto it = used.upper_bound({x + 1, -1});
	

		if (it == used.begin())
		{
			if (x + 1 == it->first)
			{
				pair<int, int> mem = *it;
				used.erase(it);
				--mem.first;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
		else if (it == used.end())
		{
			--it;
			if (it->second == x - 1)
			{
				pair<int, int> mem = *it;
				used.erase(it);
				++mem.second;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
		else
		{
			auto itr = it;
			auto itl = --it;

			if (itl->second == x - 1 && x + 1 == itr->first)
			{
				pair<int, int> meml = *itl;
				pair<int, int> memr = *itr;
				used.erase(meml);
				used.erase(memr);
				used.insert({meml.first, memr.second});
			}
			else if (itl->second == x - 1)
			{
				pair<int, int> mem = *itl;
				used.erase(itl);
				++mem.second;
				used.insert(mem);
			}
			else if (x + 1 == itr->first)
			{
				pair<int, int> mem = *itr;
				used.erase(itr);
				--mem.first;
				used.insert(mem);
			}
			else
			{
				used.insert({x, x});
			}
		}
	}
}

int main(int argc, char **argv)
{
	registerGen(argc, argv, 1);
	int max_n = atoi(argv[1]);
	int max_h = atoi(argv[2]);
	int max_t = atoi(argv[3]);
	int ans = atoi(argv[4]);
	int min_step = atoi(argv[5]);
	int max_step = atoi(argv[6]);
	int min_v = atoi(argv[7]);
	int max_v = atoi(argv[8]);

	int n = 0;	
	ll t = 0;
	ll h = 0;	
	
	ll last_h = 0;
	while (h < max_h && n < max_n && t < max_t)
	{
		ll next = min((ll)rnd.next(min_step, max_step), (max_h - h) / ans);

		ll next_h = h + ans * next;
		if (next_h > max_h)
		{
			ll to_add = (max_h - h) / ans;
			h += to_add * ans;
			t += to_add;
			break;
		}

		t += next;
		
		ll next_sub = min(rnd.next(min_v, max_v), ans - 1);
		if (next_sub != 0)
		{
			++n;
			ll at_go = rnd.next(max(next_h - next_sub + 1, last_h), max(next_h, last_h + 1));
			have.insert({at_go, next_sub});
			h = at_go - 1;
			last_h = at_go + 1;
			ans -= next_sub;
		}
		else
		{
			h = next_h;
			break;
		}
	}
	
	h = min(h, (ll)max_h);
	t = min(t, (ll)max_t);

	
	if (have.rbegin()->first > h)
		h = have.rbegin()->first;	
	
	printf("%d %lld %lld\n", n, h, t);
	for (auto it = have.begin(); it != have.end(); ++it)
	{
		printf("%d %d\n", it->first, it->second);
	}

	return 0;
}


