#include "testlib.h"

using namespace std;

typedef long long int ll;


int MIN_N = -1;
int MAX_N = -1;
int MAX_H = -1;
int MAX_T = -1;
int MAX_V = -1;
ll MAX_SUM_V = -1;

struct group
{
	string name;
	int MIN_N;
	int MAX_N;
	int MAX_H;
	int MAX_T;
	int MAX_V;
	ll MAX_SUM_V;
};

const int CNT_GROUP = 7;
group groups[CNT_GROUP] = {
	{"samples", /* MIN_N */ 1,
				/* MAX_N */ 100,
				/* MAX_H */ 100,
				/* MAX_T */ 100,
				/* MAX_V */ 100,
				/* MAX_SUM_V */ 10000ll},

	{"group1",  /* MIN_N */ 1, 
				/* MAX_N */ 1, 
				/* MAX_H */ 100,  
				/* MAX_T */ 100, 
				/* MAX_V */ 100, 
				/* MAX_SUM_V */ 10000ll},
	
	{"group2",  /* MIN_N */ 2,
				/* MAX_N */ 2,
				/* MAX_H */ 100,
				/* MAX_T */ 100,
				/* MAX_V */ 100,
				/* MAX_SUM_V */ 10000ll},
	
	{"group3",  /* MIN_N */ 1,
				/* MAX_N */ 100,
				/* MAX_H */ 100,
				/* MAX_T */ 100,
				/* MAX_V */ 100,
				/* MAX_SUM_V */ 10000ll},
	
	{"group4",  /* MIN_N */ 1,
				/* MAX_N */ 3000,
				/* MAX_H */ 3000,
				/* MAX_T */ 3000,
				/* MAX_V */ 3000,
				/* MAX_SUM_V */ 3000ll * 3000ll},
	
	{"group5",  /* MIN_N */ 1,
				/* MAX_N */ 3000,
				/* MAX_H */ 1000 * 1000 * 1000,
				/* MAX_T */ 3000,
				/* MAX_V */ 1000 * 1000 * 1000,
				/* MAX_SUM_V */ (1000ll * 1000ll * 1000ll) * (3000ll)},

	{"group6",  /* MIN_N */ 1,
				/* MAX_N */ 1000 * 100,
				/* MAX_H */ 1000 * 1000 * 1000,
				/* MAX_T */ 1000 * 1000 * 1000,
				/* MAX_V */ 1000 * 1000 * 1000,
				/* MAX_SUM_V */ (1000ll * 1000ll * 1000ll) * (1000ll * 100ll)}//,
	//{"",  /* MIN_N */ 1, // for testing
	//			/* MAX_N */ 1000 * 100,
	//			/* MAX_H */ 1000 * 1000 * 1000,
	//			/* MAX_T */ 1000 * 1000 * 1000,
	//			/* MAX_V */ 1000 * 1000 * 1000,
	//			/* MAX_SUM_V */ (1000ll * 1000ll * 1000ll) * (1000ll * 100ll)}*/
};
	

int main(int argc, char **argv)
{
	registerValidation(argc, argv);
	
	for (int i = 0; i < CNT_GROUP; ++i)
	{
		if (groups[i].name == validator.group())
		{
			MIN_N = groups[i].MIN_N;
			MAX_N = groups[i].MAX_N;
			MAX_H = groups[i].MAX_H;
			MAX_T = groups[i].MAX_T;
			MAX_V = groups[i].MAX_V;
			MAX_SUM_V = groups[i].MAX_SUM_V;
			break;
		}
	}

	ensuref(MIN_N != -1, "no group for this test");

	int n = inf.readInt(MIN_N, MAX_N, "n");
	inf.readSpace();
	int H = inf.readInt(1, MAX_H, "H");
	inf.readSpace();
	inf.readInt(1, MAX_T, "T");
	inf.readEoln();
	
	ll sum_v = 0;
	int last = 0;
	for (int i = 0; i < n; ++i)
	{
		int h = inf.readInt(last + 1, H, "h_" + vtos(i + 1));
		inf.readSpace();
		int v = inf.readInt(1, MAX_V, "v_" + vtos(i + 1));
		inf.readEoln();
		
		last = h;
		sum_v += v;
	}
	
	ensuref(sum_v <= MAX_SUM_V, "sum of v_i is %lld, but maximal available sum is %lld", sum_v, MAX_SUM_V);
	
	inf.readEof();

	return 0;
}

