#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int size = 100 * 1000;
const int inf = 2000 * 1000 * 1000 + 100;

int n, m, q;

vector <pair <int, int> > nbs[size];

void addEdge(int u, int v, int c) {
	nbs[u].pb(mp(v, c));
}

void deleteEdge(int u, int v) {
	for (int i = 0; i < (int) nbs[u].size(); i++) {
    	if (nbs[u][i].fs == v) {
    		nbs[u].erase(nbs[u].begin() + i);
    		break;
    	}
    }    	
}

int getDirect(int u, int v) {
	for (auto& e : nbs[u]) {
		if (e.fs == v)
			return e.sc;
	}

	return inf;
}

int getIndirect(int u, int v) {
	int b = inf;
	for (auto& e1 : nbs[v]) {
		for (auto& e2 : nbs[u]) {
			if (e1.fs == e2.fs && e1.sc + e2.sc < b) {
				b = e1.sc + e2.sc;				
			}
		}		
	}

	return b;
}

int main () {
    scanf("%d%d", &n, &m);

    for (int i = 0; i < m; i++) {
    	int u, v, c;
    	scanf("%d%d%d", &u, &v, &c);
    	u--, v--;

    	addEdge(u, v, c);
    	addEdge(v, u, c);
    }

    scanf("%d", &q);
    for (int i = 0; i < q; i++) {
    	int t;
    	scanf("%d", &t);
    	if (t == 1) {
    		int u, v, c;
    		scanf("%d%d%d", &u, &v, &c);
    		u--, v--;

            addEdge(u, v, c);
            addEdge(v, u, c);       	
    	}
    	if (t == 2) {
    		int u, v;
    		scanf("%d%d", &u, &v);
    		u--, v--;
    
    	    deleteEdge(u, v);
            deleteEdge(v, u);       	    
    	}
    	if (t == 3) {
    		int u, v;
    		scanf("%d%d", &u, &v);
    		u--, v--;

    		int res = min(getDirect(u, v), getIndirect(u, v));
    		if (res < inf)
    			printf("%d\n", res);
    		else
    			printf("-1\n");
    	}
    }


    return 0;
}