#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

int main (int argc, char ** argv) {
	registerGen(argc, argv, 1);

	if (argc != 4) {
		cerr << "Usage: n, m, seed" << endl;

		return 1;
	}

	int n = atoi(argv[1]);
	int m = atoi(argv[2]);

	vector <int> p;
	for (int i = 0; i < n; i++) {
		p.pb(i + 1);
	}
	shuffle(p.begin(), p.end());

	set <pair <int, int> > edges;
	for (int i = 0; i < n - 1; i++) {
		edges.insert(mp(i, i + 1));
	}
	while ((int) edges.size() < m) {
		int u = rnd.next(0, n - 1);
		int v = rnd.next(0, n - 1);
		if (u == v)
			continue;
		edges.insert(mp(min(u, v), max(u, v)));
	}

    vector <pair <int, int> > edges_set(edges.begin(), edges.end());
    shuffle(edges_set.begin(), edges_set.end());

	printf("%d %d\n", n, m);
	for (int i = 0; i < (int) edges_set.size(); i++) {
		printf("%d %d\n", p[edges_set[i].fs], p[edges_set[i].sc]);
	}

    return 0;
}