#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<bool> used;
vector<int> mt;

bool dfs(int u) {
    if (used[u]) {
        return false;
    }
    used[u] = 1;
    for (int i = 0; i < graph[u].size(); i++) {
        int to = graph[u][i];
        if (mt[to] == -1 || dfs(mt[to])) {
            mt[to] = u;
            return true;
        }
    }
    return false;
}

int main() {
    int n, m;
    cin >> n >> m;
    graph.resize(n);
    used.resize(n);
    mt.resize(n, -1);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        graph[a - 1].push_back(b - 1);
        int cnt = 0;
        mt.assign(n, -1);
        for (int i = 0; i < n; i++) {
            used.assign(n, false);
            if (dfs(i)) {
                cnt++;
            }
        }
        cout << n - cnt << ' ';
    }
}
