#include "testlib.h"
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

const int nmax = 2000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

struct point {
    ll x, y;
    point(){}
    point(ld X, ld Y) {
        x = X;
        y = Y;
    }
};

point operator + (const point &a, const point &b) { return point(a.x + b.x, a.y + b.y); }
point operator - (const point &a, const point &b) { return point(a.x - b.x, a.y - b.y); }
point operator * (const point &a, ld b) { return point(a.x * b, a.y * b); }
point operator / (const point &a, ld b) { return point(a.x / b, a.y / b); }

ld len(const point &a) { return sqrt(a.x * a.x + a.y * a.y); }
ll scal(const point &a, const point &b) { return a.x * b.x + a.y * b.y; }
ll vect(const point &a, const point &b) { return a.x * b.y - a.y * b.x; }

point turn_l(const point &a) { return point(-a.y, a.x); }
point turn_r(const point &a) { return point(a.y, -a.x); }

int MAXC = -1;

void gen_triangle(point &p1, point &p2, point &p3) {
    p1 = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
    p2 = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
    p3 = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
    while (vect(p2 - p1, p3 - p1) == 0) {
        p3 = point(rnd.next(-MAXC, MAXC), rnd.next(-MAXC, MAXC));
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    if (argc < 2) {
        cerr << "Usage: l, maxc, randseed" << endl;
        exit(1);
    }
    int n = atoi(argv[1]);
    MAXC = atoi(argv[2]);
    rnd.setSeed(atoi(argv[3]));
    vector<point> ev;
    for (int i = 0; i <= n; i++) {
        ev.pb(point(i, 0));
    }
    for (int i = 1; i <= n; i++) {
        ev.pb(point(n, i));
    }
    for (int i = n - 1; i >= 0; i--) {
        ev.pb(point(i, n));
    }
    for (int i = n - 1; i >= 0; i--) {
        ev.pb(point(0, i));
    }
    point c = point(rnd.next(1, n - 1), rnd.next(1, n - 1));
    cout << ev.size() - 1 << endl;
    for (int i = 0; i < (int)ev.size() - 1; i++) {
        point p1 = ev[i] - c, p2 = ev[i + 1] - c;
        p1 = turn_r(p1);
        p2 = turn_l(p2);
        point pq = point(rnd.next(-50, 50), rnd.next(-50, 50));
        cout << pq.x << " " << pq.y << " " << (pq + p1).x << " " << (pq + p1).y << " " << (pq + p2).x << " " << (pq + p2).y << endl;
    }
    return 0;
}

