#include "testlib.h"

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN[] = {100, 5000, 200 * 1000, 200 * 1000};
const int MAXC[] = {100, 2000 * 10, 2000 * 10, 1000 * 1000 * 1000};

struct point {
    ll x, y;
    point(){}
    point(ld X, ld Y) {
        x = X;
        y = Y;
    }
};

point operator + (const point &a, const point &b) { return point(a.x + b.x, a.y + b.y); }
point operator - (const point &a, const point &b) { return point(a.x - b.x, a.y - b.y); }
point operator * (const point &a, ld b) { return point(a.x * b, a.y * b); }
point operator / (const point &a, ld b) { return point(a.x / b, a.y / b); }

ld len(const point &a) { return sqrt(a.x * a.x + a.y * a.y); }
ll scal(const point &a, const point &b) { return a.x * b.x + a.y * b.y; }
ll vect(const point &a, const point &b) { return a.x * b.y - a.y * b.x; }

int main(int argc, char **argv) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().data());
    int n = inf.readInt(1, MAXN[group], "n");
    inf.readEoln();
    point p1, p2, p3;
    for (int i = 0; i < n; i++) {
        p1.x = inf.readInt(-MAXC[group], MAXC[group], format("p[%d][0].x", i));
        inf.readSpace();
        p1.y = inf.readInt(-MAXC[group], MAXC[group], format("p[%d][0].y", i));
        inf.readSpace();
        p2.x = inf.readInt(-MAXC[group], MAXC[group], format("p[%d][1].x", i));
        inf.readSpace();
        p2.y = inf.readInt(-MAXC[group], MAXC[group], format("p[%d][1].y", i));
        inf.readSpace();
        p3.x = inf.readInt(-MAXC[group], MAXC[group], format("p[%d][2].x", i));
        inf.readSpace();
        p3.y = inf.readInt(-MAXC[group], MAXC[group], format("p[%d][2].y", i));
        inf.readEoln();
        ensuref(vect(p2 - p1, p3 - p1) != 0, "3 points on one line");
    }
    inf.readEof();
    return 0;
}
